<num-input-ft>
<div id="{divid}">
<wms-label if="{opts.typef != null}" for="{flid}" value="{typef}" id="{flid}"></wms-label>
<input type="text" id="{fid}" name="{fname}" maxlength="{maxlength}" style="text-align: right; {style}" class="{css}" onkeyup={fkeyupfunc} value="{fvalue}" data-type="num" data-allowdecimal="{allowdecimal}" data-precision="{precision}" onfocus={focusFFunc} onblur={blurFFunc}>
<wms-label if="{opts.typee != null}" for="{elid}" value="{typee}" id="{elid}"></wms-label>
&nbsp;～&nbsp;
<wms-label if="{opts.typef != null}" for="{flid}" value="{typef}" id="{flid}"></wms-label>
<input type="text" id="{tid}" name="{tname}" maxlength="{maxlength}" style="text-align: right; {style}" class="{css}" onkeyup={tkeyupfunc} value="{tvalue}" data-type="num" data-allowdecimal="{allowdecimal}" data-precision="{precision}" onfocus={focusTFunc} onblur={blurTFunc}>
<wms-label if="{opts.typee != null}" for="{elid}" value="{typee}" id="{elid}"></wms-label>
<message tagid="{messageid}" msgstyle="{msgstyle}"></message>
</div>
<script>
	this.fid = opts.tagid + 'From';
	this.fname = (opts.name) ? opts.name + 'From' : opts.tagid + 'From';
	this.tid = opts.tagid + 'To';
	this.tname = (opts.name) ? opts.name + 'To' : opts.tagid + 'To';
	this.divid = opts.tagid + 'Div';
	this.messageid = opts.tagid + 'MessageDiv';
	this.maxlength = opts.maxlength;
	this.css = 'bakyel ' + (opts.css ? opts.css : '');
	this.style = 'ime-mode: disabled;' + (opts.style ? opts.style : '');
	this.fmt = opts.fmt ? opts.fmt : '';
	this.flid = opts.tagid + 'Fl';
	this.elid = opts.tagid + 'El';
	this.typef = opts.typef ? opts.typef : '';
	this.typee = opts.typee ? opts.typee : '';
	this.msgstyle = opts.msgstyle;
	this.allowdecimal = opts.allowdecimal;
	this.precision = opts.precision;
	
	this.posdig = 12;
	this.negdig = 12;
	
	this.fvalue = opts.valuef;
	this.tvalue = opts.valuet;
	this.regptn = /[^0-9\-\,\.]+/;

	fkeyupfunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
	}
	
	tkeyupfunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
	}

	// フォーカスin時の値を保持
	this._tmpValF = this.value;
	this._tmpValT = this.value;
	
	/**
	 * フォーカスin時の処理
	 */
	focusFFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpValF = $('#' + this.fid).val();
		$('#' + this.fid).val($('#' + this.fid).val().replaceAll(',', ''));
	}
	
	/**
	 * フォーカスin時の処理
	 */
	focusTFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpValT = $('#' + this.tid).val();
		$('#' + this.tid).val($('#' + this.tid).val().replaceAll(',', ''));
	}
	
	/**
	 * フォーカスout時の処理
	 */
	blurFFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		var aftVal = $('#' + this.fid).val();
		if (this._tmpValF != aftVal) {
			updFlg = true;
			$('#' + this.fid).attr('data-updflg', '1');
		}
		var vfOpts = {
				'allowdecimal' : this.allowdecimal ? this.allowdecimal : true,
				'precision' : this.precision ? this.precision : 0
		};
		var val = aftVal.replaceAll(',', '').replace(/[^0-9-.]|\.\..*$/igm,'');
		if (val != '') {
			val = valueFomatter('num', val, vfOpts);
			$('#' + this.fid).val(val);
		}
	}
	
	/**
	 * フォーカスout時の処理
	 */
	blurTFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		var aftVal = $('#' + this.tid).val();
		if (this._tmpValT != aftVal) {
			updFlg = true;
			$('#' + this.tid).attr('data-updflg', '1');
		}
		var vfOpts = {
				'allowdecimal' : this.allowdecimal ? this.allowdecimal : true,
				'precision' : this.precision ? this.precision : 0
		};
		var val = aftVal.replaceAll(',', '').replace(/[^0-9-.]|\.\..*$/igm,'');
		if (val != '') {
			val = valueFomatter('num', val, vfOpts);
			$('#' + this.tid).val(val);
		}
	}

	/**
	 * マウント時の処理
	 */
	this.on('updated', function() {
		setDataObj(opts.tagid, opts);
	});
	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id + 'From').attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
					$('#' + id + 'To').attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
	
</script>
</num-input-ft>
